// Generated by dts-bundle v0.7.3

declare module 'asch-contract-core' {
    
    
    
    
    
    const gasPrice: any
    const gas: any
    const verify: any
    
    type AssertFunction = (value: any, message?: string) => void
    namespace assert {
        function assert(value: any, message?: string): void
        function proxyAssert(gas: any, assert: AssertFunction): AssertFunction
    }
    
    namespace Crypto {
        namespace Crypto {
            namespace sha256 {
                function hash(value: ArrayBuffer | string): string
            }
    
            namespace ripemd160 {
                function hash(value: ArrayBuffer | string): string
            }
    
            namespace ed25519 {
                function sign(message: ArrayBuffer, privateKey: ArrayBuffer): ArrayBuffer
                function verify(message: ArrayBuffer, signature: ArrayBuffer, publicKey: ArrayBuffer): boolean
            }
        }
        function proxyCrypto(gas: any, Crypto: any): any
    }
    
    namespace Util {
        namespace Util {
            namespace Address {
                function generateNormalAddress(publicKey: ArrayBuffer | string): string
            }
        }
        function proxyUtil(gas: any, Util: any): any
    }
    
    interface KeyValueItem<T> {
        key : string,
        value : T
    }
    namespace Mapping {
        class Mapping<T>  {
            [key: string] : T | undefined
            static fromItems<T>(items: KeyValueItem<T>[]): Mapping<T>
            static isMapping<T>(obj: any): obj is Mapping<T>
            static keysOf(mapping: Mapping<any>): (string)[]
            static valuesOf<T>(mapping: Mapping<T>): T[]
            static sizeOf(mapping: Mapping<any>) : number
        }
    
        function proxyMapping(gas: any, Mapping: any): any
        function proxyMappingInstance<T>(mapping: Mapping<T>): Mapping<T>
    }
    
    namespace Vector {
        class Vector<T>  {
            [idx: number]: T | undefined
            static isVector<T>(obj: any): obj is Vector<T>
          size(): number
          push(...items: T[]): number
          pop(): Vector<T>
        }
    
        function proxyVector(gas: any, Vector: any): any
        function proxyVectorInstance<T>(gas: any, vector: Vector<T>): Vector<T>
    }
    
    namespace ByteBuffer {
        class ByteBuffer  {
            /**
                * Constructs a new ByteBuffer.
                */
            constructor( capacity?: number, littleEndian?: boolean, noAssert?: boolean );
    
            /**
                * Gets the backing buffer type.
                */
            static isByteBuffer( bb: any ): boolean;
    
            /**
                * Wraps a buffer or a string. Sets the allocated ByteBuffer's ByteBuffer#offset to 0 and its ByteBuffer#limit to the length of the wrapped data.
                * @param buffer Anything that can be wrapped
                * @param encoding String encoding if buffer is a string ("base64", "hex", "binary", defaults to "utf8")
                * @param littleEndian Whether to use little or big endian byte order. Defaults to ByteBuffer.DEFAULT_ENDIAN.
                * @param noAssert Whether to skip assertions of offsets and values. Defaults to ByteBuffer.DEFAULT_NOASSERT.
                */
            static wrap( buffer: ByteBuffer | ArrayBuffer | string, enc?: string | boolean, littleEndian?: boolean, noAssert?: boolean ): ByteBuffer;
    
            /**
                * Decodes a base64 encoded string to a ByteBuffer.
                */
            static fromBase64( str: string, littleEndian?: boolean, noAssert?: boolean ): ByteBuffer;
    
            /**
                * Decodes a binary encoded string, that is using only characters 0x00-0xFF as bytes, to a ByteBuffer.
                */
            static fromBinary( str: string, littleEndian?: boolean, noAssert?: boolean ): ByteBuffer;
    
            /**
                * Decodes a hex encoded string to a ByteBuffer.
                */
            static fromHex( str: string, littleEndian?: boolean, noAssert?: boolean ): ByteBuffer;
    
            /**
                * Decodes an UTF8 encoded string to a ByteBuffer.
                */
            static fromUTF8( str: string, littleEndian?: boolean, noAssert?: boolean ): ByteBuffer;
    
            /**
                * Reads an 8bit signed integer.
                */
            readInt8( offset?: number ): number;
    
            /**
                * Reads an 8bit unsigned integer.
                */
            readUint8( offset?: number ): number;
    
            /**
                * Reads a 16bit signed integer.
                */
            readInt16( offset?: number ): number;
    
            /**
                * Reads a 16bit unsigned integer.
                */
            readUint16( offset?: number ): number;
    
            /**
                * Reads a 32bit signed integer.
                */
            readInt32( offset?: number ): number;
    
            /**
                * Reads a 32bit unsigned integer.
                */
            readUint32( offset?: number ): number;
    
            /**
                * Reads a 64bit signed integer.
                */
            readInt64( offset?: number ): bigint;
    
            /**
                * Reads a 64bit unsigned integer.
                */
            readUint64(offset?: number): bigint;
    
            /**
                * Reads a 32bit float.
                */
            readFloat32( offset?: number ): number;
    
            /**
                * Reads a 64bit float.
                */
            readFloat64( offset?: number ): number;
    
            /**
                * Reads an UTF8 encoded string. This is an alias of ByteBuffer#readUTF8String.
                */
            readString( length: number, metrics?: number, offset?: number ): string;
    
            /**
                * Reads a NULL-terminated UTF8 encoded string. For this to work the string read must not contain any NULL characters itself.
                */
            readCString( offset?: number ): string;
    
            /**
                * Reads a length as uint32 prefixed UTF8 encoded string.
                */
            readIString( offset?: number ): string | { string: string; length: number };
    
            /**
                * Writes an 8bit signed integer.
                */
            writeInt8( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes an 8bit unsigned integer.
                */
            writeUint8( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 16bit signed integer.
                */
            writeInt16( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 16bit unsigned integer.
                */
            writeUint16( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 32bit signed integer.
                */
            writeInt32( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 32bit unsigned integer.
                */
            writeUint32( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 64bit signed integer.
                */
            writeInt64( value: number | string, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 64bit unsigned integer.
                */
            writeUint64( value: number | string, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 32bit float.
                */
            writeFloat32( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes a 64bit float.
                */
            writeFloat64( value: number, offset?: number ): ByteBuffer;
    
            /**
                * Writes an UTF8 encoded string. This is an alias of ByteBuffer#writeUTF8String.
                */
            writeString( str: string, offset?: number ): ByteBuffer | number;
    
            /**
                * Writes a NULL-terminated UTF8 encoded string. For this to work the specified string must not contain any NULL characters itself.
                */
            writeCString( str: string, offset?: number ): ByteBuffer;
    
            /**
                * Writes a length as uint32 prefixed UTF8 encoded string.
                */
            writeIString( str: string, offset?: number ): ByteBuffer;
    
            /**
                * Appends some data to this ByteBuffer. This will overwrite any contents behind the specified offset up to the appended data's length.
                */
            append( source: ByteBuffer | ArrayBuffer | string, encoding?: string | number, offset?: number ): ByteBuffer;
    
            /**
                * Creates a cloned instance of this ByteBuffer, preset with this ByteBuffer's values for ByteBuffer#offset, ByteBuffer#markedOffset and ByteBuffer#limit.
                */
            clone( copy?: boolean ): ByteBuffer;
    
            /**
                * Makes this ByteBuffer ready for a new sequence of write or relative read operations. Sets limit = offset and offset = 0. Make sure always to flip a ByteBuffer when all relative read or write operations are complete.
                */
            flip(): ByteBuffer;
    
            /**
                * Resizes this ByteBuffer to be backed by a buffer of at least the given capacity. Will do nothing if already that large or larger.
                */
            resize( capacity: number ): ByteBuffer;
    
            /**
                * Returns a copy of the backing buffer that contains this ByteBuffer's contents. Contents are the bytes between ByteBuffer#offset and ByteBuffer#limit. Will transparently ByteBuffer#flip this ByteBuffer if offset > limit but the actual offsets remain untouched.
                */
            toBuffer( forceCopy?: boolean ): ArrayBuffer;
    
            /**
                * Converts the ByteBuffer's contents to a string.
                */
            toString( encoding?: string ): string;
    
            /**
                * Encodes this ByteBuffer's contents to a base64 encoded string.
                */
            toBase64( begin?: number, end?: number ): string;
    
            /**
                * Encodes this ByteBuffer to a binary encoded string, that is using only characters 0x00-0xFF as bytes.
                */
            toBinary( begin?: number, end?: number ): string;
    
            /**
                * Encodes this ByteBuffer's contents to a hex encoded string.
                */
            toHex( begin?: number, end?: number ): string;
    
            /**
                * Encodes this ByteBuffer's contents between ByteBuffer#offset and ByteBuffer#limit to an UTF8 encoded string.
                */
            toUTF8(): string;
        }
    
        function proxyByteBuffer(gas: any, ByteBuffer: any): any
        function proxyByteBufferInstance(gas: any, bb: ByteBuffer): ByteBuffer
    }
    
    interface Function {
    }
    
    interface ArrayLike<T> {
            readonly length: number;
            readonly [n: number]: T;
    }
    
    interface Object {
    }
    
    type Partial<T> = {
        [key in keyof T]: T[key]
    }
    
    interface ObjectConstructor {
            new(value?: any): Object;
            (): any;
            (value: any): any;
    
             /**
                * Copy the values of all of the enumerable own properties from one or more source objects to a
                * target object. Returns the target object.
                * @param target The target object to copy to.
                * @param source The source object from which to copy properties.
                */
            assign<T>(target: T, source: Partial<T>): T;
    
            /**
                * Copy the values of all of the enumerable own properties from one or more source objects to a
                * target object. Returns the target object.
                * @param target The target object to copy to.
                * @param sources One or more source objects from which to copy properties
                */
            assign<T>(target: T, ...sources: Partial<T>[]): T;
    
            /**
                * Returns an array of key/values of the enumerable properties of an object
                * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.
                */
            entries<T>(o: { [s: string]: T } | ArrayLike<T>): [string, T][];
    
            /**
                * Returns an array of key/values of the enumerable properties of an object
                * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.
                */
            entries(o: {}): [string, any][];
    
            /**
                 * Returns the names of the enumerable properties and methods of an object.
                 * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.
                 */
            keys(o: {}): string[];
    
            /**
                * Returns an array of values of the enumerable properties of an object
                * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.
                */
            values<T>(o: { [s: string]: T } |  ArrayLike<T>): T[];
    
            /**
                * Returns an array of values of the enumerable properties of an object
                * @param o Object that contains the properties and methods. This can be an object that you created or an existing Document Object Model (DOM) object.
                */
            values(o: {}): any[];
    
            /**
                * Returns true if the values are the same value, false otherwise.
                * @param value1 The first value.
                * @param value2 The second value.
                */
            is(value1: any, value2: any): boolean;
    }
    
    /**
         * Provides functionality common to all JavaScript objects.
         */
    const Object: ObjectConstructor;
    
    interface String {
            /** Returns a string representation of a string. */
            toString(): string;
    
            /**
                 * Returns the character at the specified index.
                 * @param pos The zero-based index of the desired character.
                 */
            charAt(pos: number): string;
    
            /**
                 * Returns the Unicode value of the character at the specified location.
                 * @param index The zero-based index of the desired character. If there is no character at the specified index, NaN is returned.
                 */
            charCodeAt(index: number): number;
    
            /**
                * Returns true if the sequence of elements of searchString converted to a String is the
                * same as the corresponding elements of this object (converted to a String) starting at
                * position. Otherwise returns false.
                */
            startsWith(searchString: string, position?: number): boolean;
    
            /**
                * Returns true if the sequence of elements of searchString converted to a String is the
                * same as the corresponding elements of this object (converted to a String) starting at
                * endPosition – length(this). Otherwise returns false.
                */
            endsWith(searchString: string, endPosition?: number): boolean;
    
            /**
                * Returns true if searchString appears as a substring of the result of converting this
                * object to a String, at one or more positions that are
                * greater than or equal to position; otherwise, returns false.
                * @param searchString search string
                * @param position If position is undefined, 0 is assumed, so as to search all of the String.
                */
            includes(searchString: string, position?: number): boolean;
    
            /**
                 * Returns the position of the first occurrence of a substring.
                 * @param searchString The substring to search for in the string
                 * @param position The index at which to begin searching the String object. If omitted, search starts at the beginning of the string.
                 */
            indexOf(searchString: string, position?: number): number;
    
            /**
                 * Returns the last occurrence of a substring in the string.
                 * @param searchString The substring to search for.
                 * @param position The index at which to begin searching. If omitted, the search begins at the end of the string.
                 */
            lastIndexOf(searchString: string, position?: number): number;
    
            /**
                * Pads the current string with a given string (possibly repeated) so that the resulting string reaches a given length.
                * The padding is applied from the start (left) of the current string.
                *
                * @param maxLength The length of the resulting string once the current string has been padded.
                *        If this parameter is smaller than the current string's length, the current string will be returned as it is.
                *
                * @param fillString The string to pad the current string with.
                *        If this string is too long, it will be truncated and the left-most part will be applied.
                *        The default value for this parameter is " " (U+0020).
                */
            padStart(maxLength: number, fillString?: string): string;
    
            /**
                * Pads the current string with a given string (possibly repeated) so that the resulting string reaches a given length.
                * The padding is applied from the end (right) of the current string.
                *
                * @param maxLength The length of the resulting string once the current string has been padded.
                *        If this parameter is smaller than the current string's length, the current string will be returned as it is.
                *
                * @param fillString The string to pad the current string with.
                *        If this string is too long, it will be truncated and the left-most part will be applied.
                *        The default value for this parameter is " " (U+0020).
                */
            padEnd(maxLength: number, fillString?: string): string;
    
            /**
                * Returns a String value that is made from count copies appended together. If count is 0,
                * the empty string is returned.
                * @param count number of copies to append
                */
            repeat(count: number): string;
    
            /**
                 * Returns a section of a string.
                 * @param start The index to the beginning of the specified portion of stringObj.
                 * @param end The index to the end of the specified portion of stringObj. The substring includes the characters up to, but not including, the character indicated by end.
                 * If this value is not specified, the substring continues to the end of stringObj.
                 */
            slice(start?: number, end?: number): string;
    
            // IE extensions
            /**
                 * Gets a substring beginning at the specified location and having the specified length.
                 * @param from The starting position of the desired substring. The index of the first character in the string is zero.
                 * @param length The number of characters to include in the returned substring.
                 */
            substr(from: number, length?: number): string;
    
            /**
                 * Split a string into substrings using the specified separator and return them as an array.
                 * @param separator A string that identifies character or characters to use in separating the string. If omitted, a single-element array containing the entire string is returned.
                 * @param limit A value used to limit the number of elements returned in the array.
                 */
            split(separator: string, limit?: number): string[];
    
            /**
                 * Returns the substring at the specified location within a String object.
                 * @param start The zero-based index number indicating the beginning of the substring.
                 * @param end Zero-based index number indicating the end of the substring. The substring includes the characters up to, but not including, the character indicated by end.
                 * If end is omitted, the characters from start through the end of the original string are returned.
                 */
            substring(start: number, end?: number): string;
    
            /** Converts all the alphabetic characters in a string to lowercase. */
            toLowerCase(): string;
    
            /** Converts all the alphabetic characters in a string to uppercase. */
            toUpperCase(): string;
    
            /** Removes the leading and trailing white space and line terminator characters from a string. */
            trim(): string;
    
            /** Removes the leading white space and line terminator characters from a string. */
            trimLeft(): string;
    
            /** Removes the trailing white space and line terminator characters from a string. */
            trimRight(): string;
    
            /** Returns the length of a String object. */
            readonly length: number;
    
            readonly [index: number]: string;
    }
    
    interface StringConstructor {
            new(value?: any): String;
            (value?: any): string;
            fromCharCode(...codes: number[]): string;
    }
    
    /**
         * Allows manipulation and formatting of text strings and determination and location of substrings within strings.
         */
    const String: StringConstructor;
    
    interface Number {
            /**
                 * Returns a string representation of an object.
                 * @param radix Specifies a radix for converting numeric values to strings. This value is only used for numbers.
                 */
            toString(radix?: number): string;
    
            /**
                 * Returns a string representing a number in fixed-point notation.
                 * @param fractionDigits Number of digits after the decimal point. Must be in the range 0 - 20, inclusive.
                 */
            toFixed(fractionDigits?: number): string;
    
            /**
                 * Returns a string containing a number represented in exponential notation.
                 * @param fractionDigits Number of digits after the decimal point. Must be in the range 0 - 20, inclusive.
                 */
            toExponential(fractionDigits?: number): string;
    
            /**
                 * Returns a string containing a number represented either in exponential or fixed-point notation with a specified number of digits.
                 * @param precision Number of significant digits. Must be in the range 1 - 21, inclusive.
                 */
            toPrecision(precision?: number): string;
    }
    
    interface NumberConstructor {
            /** The largest number that can be represented in JavaScript. Equal to approximately 1.79E+308. */
            readonly MAX_VALUE: number;
    
            /** The closest number to zero that can be represented in JavaScript. Equal to approximately 5.00E-324. */
            readonly MIN_VALUE: number;
    
            /**
                 * A value that is not a number.
                 * In equality comparisons, NaN does not equal any value, including itself. To test whether a value is equivalent to NaN, use the isNaN function.
                 */
            readonly NaN: number;
    
            /**
                * Returns a Boolean value that indicates whether a value is the reserved value NaN (not a
                * number). Unlike the global isNaN(), Number.isNaN() doesn't forcefully convert the parameter
                * to a number. Only values of the type number, that are also NaN, result in true.
                * @param number A numeric value.
                */
            isNaN(number: number): boolean;
    
            /**
                * Converts a string to a floating-point number.
                * @param string A string that contains a floating-point number.
                */
            parseFloat(string: string): number;
    
            /**
                * Converts A string to an integer.
                * @param s A string to convert into a number.
                * @param radix A value between 2 and 36 that specifies the base of the number in numString.
                * If this argument is not supplied, strings with a prefix of '0x' are considered hexadecimal.
                * All other strings are considered decimal.
                */
            parseInt(string: string, radix?: number): number;
    }
    
    /** An object that represents a number of any kind. All JavaScript numbers are 64-bit floating-point numbers. */
    const Number: NumberConstructor;
    
    interface Math {
            /** The mathematical constant e. This is Euler's number, the base of natural logarithms. */
            readonly E: number;
            /** The natural logarithm of 10. */
            readonly LN10: number;
            /** The natural logarithm of 2. */
            readonly LN2: number;
            /** The base-2 logarithm of e. */
            readonly LOG2E: number;
            /** The base-10 logarithm of e. */
            readonly LOG10E: number;
            /** Pi. This is the ratio of the circumference of a circle to its diameter. */
            readonly PI: number;
            /** The square root of 0.5, or, equivalently, one divided by the square root of 2. */
            readonly SQRT1_2: number;
            /** The square root of 2. */
            readonly SQRT2: number;
            /**
                 * Returns the absolute value of a number (the value without regard to whether it is positive or negative).
                 * For example, the absolute value of -5 is the same as the absolute value of 5.
                 * @param x A numeric expression for which the absolute value is needed.
                 */
            abs(x: number): number;
            /**
                 * Returns the arc cosine (or inverse cosine) of a number.
                 * @param x A numeric expression.
                 */
            acos(x: number): number;
            /**
                 * Returns the arcsine of a number.
                 * @param x A numeric expression.
                 */
            asin(x: number): number;
            /**
                 * Returns the arctangent of a number.
                 * @param x A numeric expression for which the arctangent is needed.
                 */
            atan(x: number): number;
            /**
                 * Returns the angle (in radians) from the X axis to a point.
                 * @param y A numeric expression representing the cartesian y-coordinate.
                 * @param x A numeric expression representing the cartesian x-coordinate.
                 */
            atan2(y: number, x: number): number;
            /**
                 * Returns the smallest integer greater than or equal to its numeric argument.
                 * @param x A numeric expression.
                 */
            ceil(x: number): number;
            /**
                 * Returns the cosine of a number.
                 * @param x A numeric expression that contains an angle measured in radians.
                 */
            cos(x: number): number;
            /**
                 * Returns e (the base of natural logarithms) raised to a power.
                 * @param x A numeric expression representing the power of e.
                 */
            exp(x: number): number;
            /**
                 * Returns the greatest integer less than or equal to its numeric argument.
                 * @param x A numeric expression.
                 */
            floor(x: number): number;
            /**
                 * Returns the natural logarithm (base e) of a number.
                 * @param x A numeric expression.
                 */
            log(x: number): number;
            /**
                 * Returns the larger of a set of supplied numeric expressions.
                 * @param values Numeric expressions to be evaluated.
                 */
            max(...values: number[]): number;
            /**
                 * Returns the smaller of a set of supplied numeric expressions.
                 * @param values Numeric expressions to be evaluated.
                 */
            min(...values: number[]): number;
            /**
                 * Returns the value of a base expression taken to a specified power.
                 * @param x The base value of the expression.
                 * @param y The exponent value of the expression.
                 */
            pow(x: number, y: number): number;
            /**
                 * Returns a supplied numeric expression rounded to the nearest number.
                 * @param x The value to be rounded to the nearest number.
                 */
            round(x: number): number;
            /**
                 * Returns the sine of a number.
                 * @param x A numeric expression that contains an angle measured in radians.
                 */
            sin(x: number): number;
            /**
                 * Returns the square root of a number.
                 * @param x A numeric expression.
                 */
            sqrt(x: number): number;
            /**
                 * Returns the tangent of a number.
                 * @param x A numeric expression that contains an angle measured in radians.
                 */
            tan(x: number): number;
            /**
                * Returns the number of leading zero bits in the 32-bit binary representation of a number.
                * @param x A numeric expression.
                */
            clz32(x: number): number;
    
            /**
                * Returns the result of 32-bit multiplication of two numbers.
                * @param x First number
                * @param y Second number
                */
            imul(x: number, y: number): number;
    
            /**
                * Returns the sign of the x, indicating whether x is positive, negative or zero.
                * @param x The numeric expression to test
                */
            sign(x: number): number;
    
            /**
                * Returns the base 10 logarithm of a number.
                * @param x A numeric expression.
                */
            log10(x: number): number;
    
            /**
                * Returns the base 2 logarithm of a number.
                * @param x A numeric expression.
                */
            log2(x: number): number;
    
            /**
                * Returns the natural logarithm of 1 + x.
                * @param x A numeric expression.
                */
            log1p(x: number): number;
    
            /**
                * Returns the result of (e^x - 1), which is an implementation-dependent approximation to
                * subtracting 1 from the exponential function of x (e raised to the power of x, where e
                * is the base of the natural logarithms).
                * @param x A numeric expression.
                */
            expm1(x: number): number;
    
            /**
                * Returns the hyperbolic cosine of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            cosh(x: number): number;
    
            /**
                * Returns the hyperbolic sine of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            sinh(x: number): number;
    
            /**
                * Returns the hyperbolic tangent of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            tanh(x: number): number;
    
            /**
                * Returns the inverse hyperbolic cosine of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            acosh(x: number): number;
    
            /**
                * Returns the inverse hyperbolic sine of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            asinh(x: number): number;
    
            /**
                * Returns the inverse hyperbolic tangent of a number.
                * @param x A numeric expression that contains an angle measured in radians.
                */
            atanh(x: number): number;
    
            /**
                * Returns the square root of the sum of squares of its arguments.
                * @param values Values to compute the square root for.
                *     If no arguments are passed, the result is +0.
                *     If there is only one argument, the result is the absolute value.
                *     If any argument is +Infinity or -Infinity, the result is +Infinity.
                *     If any argument is NaN, the result is NaN.
                *     If all arguments are either +0 or −0, the result is +0.
                */
            hypot(...values: number[]): number;
    
            /**
                * Returns the integral part of the a numeric expression, x, removing any fractional digits.
                * If x is already an integer, the result is x.
                * @param x A numeric expression.
                */
            trunc(x: number): number;
    
            /**
                * Returns the nearest single precision float representation of a number.
                * @param x A numeric expression.
                */
            fround(x: number): number;
    
            /**
                * Returns an implementation-dependent approximation to the cube root of number.
                * @param x A numeric expression.
                */
            cbrt(x: number): number;
    }
    /** An intrinsic object that provides basic mathematics functionality and constants. */
    const Math: Math;
    
    interface IteratorResult<T> {
            done: boolean;
            value: T;
    }
    
    interface Iterator<T> {
            next(value?: any): IteratorResult<T>;
            return?(value?: any): IteratorResult<T>;
            throw?(e?: any): IteratorResult<T>;
    }
    
    interface IterableIterator<T> extends Iterator<T> {
    }
    
    
    interface ReadonlyArray<T> {
            /**
                 * Gets the length of the array. This is a number one higher than the highest element defined in an array.
                 */
            readonly length: number;
            /**
                 * Returns a string representation of an array.
                 */
            toString(): string;
            /**
                * Returns the this object after copying a section of the array identified by start and end
                * to the same array starting at position target
                * @param target If target is negative, it is treated as length+target where length is the
                * length of the array.
                * @param start If start is negative, it is treated as length+start. If end is negative, it
                * is treated as length+end.
                * @param end If not specified, length of the this object is used as its default value.
                */
            copyWithin(target: number, start: number, end?: number): this;
            /**
                 * Combines two or more arrays.
                 * @param items Additional items to add to the end of array1.
                 */
            concat(...items: ConcatArray<T>[]): T[];
            /**
                 * Combines two or more arrays.
                 * @param items Additional items to add to the end of array1.
                 */
            concat(...items: (T | ConcatArray<T>)[]): T[];
            /**
                 * Adds all the elements of an array separated by the specified separator string.
                 * @param separator A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.
                 */
            join(separator?: string): string;
            /**
                 * Returns a section of an array.
                 * @param start The beginning of the specified portion of the array.
                 * @param end The end of the specified portion of the array.
                 */
            slice(start?: number, end?: number): T[];
            /**
                 * Returns the index of the first occurrence of a value in an array.
                 * @param searchElement The value to locate in the array.
                 * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.
                 */
            indexOf(searchElement: T, fromIndex?: number): number;
            /**
                 * Returns the index of the last occurrence of a specified value in an array.
                 * @param searchElement The value to locate in the array.
                 * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.
                 */
            lastIndexOf(searchElement: T, fromIndex?: number): number;
            /**
                 * Determines whether all the members of an array satisfy the specified test.
                 * @param callbackfn A function that accepts up to three arguments. The every method calls the callbackfn function for each element in array1 until the callbackfn returns false, or until the end of the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            every(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => boolean, thisArg?: any): boolean;
            /**
                 * Determines whether the specified callback function returns true for any element of an array.
                 * @param callbackfn A function that accepts up to three arguments. The some method calls the callbackfn function for each element in array1 until the callbackfn returns true, or until the end of the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            some(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => boolean, thisArg?: any): boolean;
            /**
                 * Performs the specified action for each element in an array.
                 * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.
                 * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            forEach(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => void, thisArg?: any): void;
            /**
                 * Calls a defined callback function on each element of an array, and returns an array that contains the results.
                 * @param callbackfn A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            map<U>(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => U, thisArg?: any): U[];
            /**
                * Returns the elements of an array that meet the condition specified in a callback function.
                * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.
                * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                */
            filter<S extends T>(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => value is S, thisArg?: any): S[];
            /**
                 * Returns the elements of an array that meet the condition specified in a callback function.
                 * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            filter(callbackfn: (value: T, index: number, array: ReadonlyArray<T>) => any, thisArg?: any): T[];
            /**
                 * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T): T;
            reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T, initialValue: T): T;
            /**
                 * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduce<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => U, initialValue: U): U;
            /**
                 * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T): T;
            reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => T, initialValue: T): T;
            /**
                 * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduceRight<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: ReadonlyArray<T>) => U, initialValue: U): U;
            /**
                * Determines whether an array includes a certain element, returning true or false as appropriate.
                * @param searchElement The element to search for.
                * @param fromIndex The position in this array at which to begin searching for searchElement.
                */
            includes(searchElement: T, fromIndex?: number): boolean;
            /**
                * Returns the value of the first element in the array where predicate is true, and undefined
                * otherwise.
                * @param predicate find calls predicate once for each element of the array, in ascending
                * order, until it finds one where predicate returns true. If such an element is found, find
                * immediately returns that element value. Otherwise, find returns undefined.
                * @param thisArg If provided, it will be used as the this value for each invocation of
                * predicate. If it is not provided, undefined is used instead.
                */
            find<S extends T>(predicate: (this: void, value: T, index: number, obj: T[]) => value is S, thisArg?: any): S | undefined;
            find(predicate: (value: T, index: number, obj: T[]) => boolean, thisArg?: any): T | undefined;
    
            /**
                * Returns the index of the first element in the array where predicate is true, and -1
                * otherwise.
                * @param predicate find calls predicate once for each element of the array, in ascending
                * order, until it finds one where predicate returns true. If such an element is found,
                * findIndex immediately returns that element index. Otherwise, findIndex returns -1.
                * @param thisArg If provided, it will be used as the this value for each invocation of
                * predicate. If it is not provided, undefined is used instead.
                */
            findIndex(predicate: (value: T, index: number, obj: T[]) => boolean, thisArg?: any): number;
    
            readonly [n: number]: T;
    }
    
    interface ConcatArray<T> {
            readonly length: number;
            readonly [n: number]: T;
            join(separator?: string): string;
            slice(start?: number, end?: number): T[];
    }
    
    interface Array<T> {
            /**
                 * Gets or sets the length of the array. This is a number one higher than the highest element defined in an array.
                 */
            length: number;
            /**
                * Returns the this object after copying a section of the array identified by start and end
                * to the same array starting at position target
                * @param target If target is negative, it is treated as length+target where length is the
                * length of the array.
                * @param start If start is negative, it is treated as length+start. If end is negative, it
                * is treated as length+end.
                * @param end If not specified, length of the this object is used as its default value.
                */
            copyWithin(target: number, start: number, end?: number): this;
            /**
                 * Returns a string representation of an array.
                 */
            toString(): string;
            /**
                 * Removes the last element from an array and returns it.
                 */
            pop(): T | undefined;
            /**
                 * Appends new elements to an array, and returns the new length of the array.
                 * @param items New elements of the Array.
                 */
            push(...items: T[]): number;
            /**
                 * Combines two or more arrays.
                 * @param items Additional items to add to the end of array1.
                 */
            concat(...items: ConcatArray<T>[]): T[];
            /**
                 * Combines two or more arrays.
                 * @param items Additional items to add to the end of array1.
                 */
            concat(...items: (T | ConcatArray<T>)[]): T[];
            /**
                 * Adds all the elements of an array separated by the specified separator string.
                 * @param separator A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.
                 */
            join(separator?: string): string;
            /**
                 * Reverses the elements in an Array.
                 */
            reverse(): T[];
            /**
                 * Removes the first element from an array and returns it.
                 */
            shift(): T | undefined;
            /**
                 * Returns a section of an array.
                 * @param start The beginning of the specified portion of the array.
                 * @param end The end of the specified portion of the array.
                 */
            slice(start?: number, end?: number): T[];
            /**
                 * Sorts an array.
                 * @param compareFn The name of the function used to determine the order of the elements. If omitted, the elements are sorted in ascending, ASCII character order.
                 */
            sort(compareFn?: (a: T, b: T) => number): this;
            /**
                 * Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.
                 * @param start The zero-based location in the array from which to start removing elements.
                 * @param deleteCount The number of elements to remove.
                 */
            splice(start: number, deleteCount?: number): T[];
            /**
                 * Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.
                 * @param start The zero-based location in the array from which to start removing elements.
                 * @param deleteCount The number of elements to remove.
                 * @param items Elements to insert into the array in place of the deleted elements.
                 */
            splice(start: number, deleteCount: number, ...items: T[]): T[];
            /**
                 * Inserts new elements at the start of an array.
                 * @param items  Elements to insert at the start of the Array.
                 */
            unshift(...items: T[]): number;
            /**
                 * Returns the index of the first occurrence of a value in an array.
                 * @param searchElement The value to locate in the array.
                 * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.
                 */
            indexOf(searchElement: T, fromIndex?: number): number;
            /**
                 * Returns the index of the last occurrence of a specified value in an array.
                 * @param searchElement The value to locate in the array.
                 * @param fromIndex The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.
                 */
            lastIndexOf(searchElement: T, fromIndex?: number): number;
            /**
                 * Determines whether all the members of an array satisfy the specified test.
                 * @param callbackfn A function that accepts up to three arguments. The every method calls the callbackfn function for each element in array1 until the callbackfn returns false, or until the end of the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            every(callbackfn: (value: T, index: number, array: T[]) => boolean, thisArg?: any): boolean;
            /**
                 * Determines whether the specified callback function returns true for any element of an array.
                 * @param callbackfn A function that accepts up to three arguments. The some method calls the callbackfn function for each element in array1 until the callbackfn returns true, or until the end of the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            some(callbackfn: (value: T, index: number, array: T[]) => boolean, thisArg?: any): boolean;
            /**
                 * Performs the specified action for each element in an array.
                 * @param callbackfn  A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.
                 * @param thisArg  An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            forEach(callbackfn: (value: T, index: number, array: T[]) => void, thisArg?: any): void;
            /**
                 * Calls a defined callback function on each element of an array, and returns an array that contains the results.
                 * @param callbackfn A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            map<U>(callbackfn: (value: T, index: number, array: T[]) => U, thisArg?: any): U[];
            /**
                * Returns the elements of an array that meet the condition specified in a callback function.
                * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.
                * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                */
            filter<S extends T>(callbackfn: (value: T, index: number, array: T[]) => value is S, thisArg?: any): S[];
            /**
                 * Returns the elements of an array that meet the condition specified in a callback function.
                 * @param callbackfn A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.
                 * @param thisArg An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.
                 */
            filter(callbackfn: (value: T, index: number, array: T[]) => any, thisArg?: any): T[];
            /**
                 * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T): T;
            reduce(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T, initialValue: T): T;
            /**
                 * Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduce<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: T[]) => U, initialValue: U): U;
            /**
                 * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T): T;
            reduceRight(callbackfn: (previousValue: T, currentValue: T, currentIndex: number, array: T[]) => T, initialValue: T): T;
            /**
                 * Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.
                 * @param callbackfn A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.
                 * @param initialValue If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.
                 */
            reduceRight<U>(callbackfn: (previousValue: U, currentValue: T, currentIndex: number, array: T[]) => U, initialValue: U): U;
            /**
                * Determines whether an array includes a certain element, returning true or false as appropriate.
                * @param searchElement The element to search for.
                * @param fromIndex The position in this array at which to begin searching for searchElement.
                */
            includes(searchElement: T, fromIndex?: number): boolean;
            /**
                * Returns the value of the first element in the array where predicate is true, and undefined
                * otherwise.
                * @param predicate find calls predicate once for each element of the array, in ascending
                * order, until it finds one where predicate returns true. If such an element is found, find
                * immediately returns that element value. Otherwise, find returns undefined.
                * @param thisArg If provided, it will be used as the this value for each invocation of
                * predicate. If it is not provided, undefined is used instead.
                */
            find<S extends T>(predicate: (this: void, value: T, index: number, obj: T[]) => value is S, thisArg?: any): S | undefined;
            find(predicate: (value: T, index: number, obj: T[]) => boolean, thisArg?: any): T | undefined;
    
            /**
                * Returns the index of the first element in the array where predicate is true, and -1
                * otherwise.
                * @param predicate find calls predicate once for each element of the array, in ascending
                * order, until it finds one where predicate returns true. If such an element is found,
                * findIndex immediately returns that element index. Otherwise, findIndex returns -1.
                * @param thisArg If provided, it will be used as the this value for each invocation of
                * predicate. If it is not provided, undefined is used instead.
                */
            findIndex(predicate: (value: T, index: number, obj: T[]) => boolean, thisArg?: any): number;
    
            /**
                * Returns the this object after filling the section identified by start and end with value
                * @param value value to fill array section with
                * @param start index to start filling the array at. If start is negative, it is treated as
                * length+start where length is the length of the array.
                * @param end index to stop filling the array at. If end is negative, it is treated as
                * length+end.
                */
            fill(value: T, start?: number, end?: number): this;
    
            [n: number]: T;
    }
    
    interface ArrayConstructor {
            new(arrayLength?: number): any[];
            new <T>(arrayLength: number): T[];
            new <T>(...items: T[]): T[];
            (arrayLength?: number): any[];
            <T>(arrayLength: number): T[];
            <T>(...items: T[]): T[];
            isArray(arg: any): arg is Array<any>;
            readonly prototype: Array<any>;
            /**
                * Creates an array from an array-like object.
                * @param arrayLike An array-like object to convert to an array.
                */
            from<T>(arrayLike: ArrayLike<T>): T[];
    
            /**
                * Creates an array from an iterable object.
                * @param arrayLike An array-like object to convert to an array.
                * @param mapfn A mapping function to call on every element of the array.
                * @param thisArg Value of 'this' used to invoke the mapfn.
                */
            from<T, U>(arrayLike: ArrayLike<T>, mapfn: (v: T, k: number) => U, thisArg?: any): U[];
    
            /**
                * Returns a new array from a set of elements.
                * @param items A set of elements to include in the new array object.
                */
            of<T>(...items: T[]): T[];
    }
    
    const Array: ArrayConstructor;
    
    interface ArrayBuffer {
            /**
                 * Read-only. The length of the ArrayBuffer (in bytes).
                 */
            readonly byteLength: number;
    }
    
    interface BigInt {
            /**
                 * Returns a string representation of an object.
                 * @param radix Specifies a radix for converting numeric values to strings.
                 */
            toString(radix?: number): string;
    }
    
    interface BigIntConstructor {
            (value?: any): bigint;
            readonly prototype: BigInt;
    }
    
    const BigInt: BigIntConstructor;
}

